--[[
	Project: BookOfTheFallen
	Version: 1.0.0
	Author: NerfedWar (http://www.nerfedwar.net - nerfed.war@gmail.com)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]

-- initialise
if not BOTF then BOTF = {} end
if not BOTF.Book then BOTF.Book = {} end

-- @field define the Bookmark class
BOTF.Book.Bookmark = class()

-- Bookmark class
-- @param book the Book pagesFrame
function BOTF.Book.Bookmark:init(book, page, size, x, y)

  -- @field store a reference to the Book pagesFrame
  self.theBook = book
  self.thePage = page

  -- create the bookmark text
  self.text = UI.CreateFrame("Text", "BOTFBookmark", self.theBook.bookFrame)
  self.text:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", x, y)
  self.text:SetLayer(4)
  self.text:SetText(self.thePage)
  self.text:SetFont("BOTF", "Bloody.ttf")
  self.text:SetFontSize(size)
  self.text:SetFontColor(0.5, 0.5, 0.5, 1)
  self.text:SetVisible(true)
  self.text.object = self
  self.text:EventAttach(Event.UI.Input.Mouse.Cursor.In, function(self, h)
     self:SetFontColor(1, 0.5, 0.5, 1)
  end, "Bookmark Mouse In")
  self.text:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
     self:SetFontColor(0.5, 0.5, 0.5, 1)
  end, "Bookmark Mouse Out")
  self.text:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
    self.object.theBook:setPage(string.lower(self.object.thePage))
  end, "Bookmark LeftClick")
end
