--[[
	Project: BookOfTheFallen
	Version: 1.0.0
	Author: NerfedWar (http://www.nerfedwar.net - nerfed.war@gmail.com)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]

-- initialise globals
if not BOTF then BOTF = {} end
if not BOTF.Book then BOTF.Book = {} end

-- @field define the Detail class
BOTF.Book.Detail = class(BOTF.Book.BasicPage)

-- Detail class constructor
-- @param book the Book pagesFrame
function BOTF.Book.Detail:init(book)

  -- @field store a reference to the Book pagesFrame
  self.theBook = book

  -- create lifetimeDetailStats text block
  self.lifetimeDetailStats = UI.CreateFrame("Text", "BOTFBookDetailStats", self.theBook.bookFrame)
  self.lifetimeDetailStats:SetWidth(260)
  self.lifetimeDetailStats:SetHeight(300)
  self.lifetimeDetailStats:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT",510, -33)
  self.lifetimeDetailStats:SetLayer(2)
  self.lifetimeDetailStats:SetText("")
  self.lifetimeDetailStats:SetFont("BOTF", "MONOFONT.TTF")
  self.lifetimeDetailStats:SetFontSize(15)
  self.lifetimeDetailStats:SetFontColor(0.3, 0.2, 0.2, 1)
  self.lifetimeDetailStats:SetVisible(true)

  -- create sessionDetailStats text block
  self.sessionDetailStats = UI.CreateFrame("Text", "BOTFBookDetailStats", self.theBook.bookFrame)
  self.sessionDetailStats:SetWidth(260)
  self.sessionDetailStats:SetHeight(300)
  self.sessionDetailStats:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 510, 307)
  self.sessionDetailStats:SetLayer(2)
  self.sessionDetailStats:SetText("")
  self.sessionDetailStats:SetFont("BOTF", "MONOFONT.TTF")
  self.sessionDetailStats:SetFontSize(15)
  self.sessionDetailStats:SetFontColor(0.2, 0.3, 0.2, 1)
  self.sessionDetailStats:SetVisible(true)
  
    -- create notesBlock text block
  self.notesBlock = UI.CreateFrame("Text", "BOTFBookDetailStats", self.theBook.bookFrame)
  self.notesBlock:SetWidth(260)
  self.notesBlock:SetHeight(250)
  self.notesBlock:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 155, 310)
  self.notesBlock:SetLayer(2)
  self.notesBlock:SetText("")
  self.notesBlock:SetFont("BOTF", "MONOFONT.TTF")
  self.notesBlock:SetFontSize(15)
  self.notesBlock:SetFontColor(0.3, 0.2, 0.2, 1)
  self.notesBlock:SetVisible(true)
  
  -- create name plate
  self.name_plate = UI.CreateFrame("Text", "BOTFUIDetailNamePlate", self.theBook.bookFrame)
  self.name_plate:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 98, 42)
  self.name_plate:SetLayer(2)	
  self.name_plate:SetText("Name goes here")
 -- self.name_plate:ResizeToText()
  self.name_plate:SetFontSize(20)
  self.name_plate:SetFontColor(0.8,0.3,0.3,0.8)
  self.name_plate:SetVisible(false)
  
  -- create calling/level plate
  self.calling_plate = UI.CreateFrame("Text", "BOTFUIDetailCallingPlate", self.theBook.bookFrame)
  self.calling_plate:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 98, 76)
  self.calling_plate:SetLayer(2)	
  self.calling_plate:SetText("Calling - Level XX")
  --self.calling_plate:ResizeToText()
  self.calling_plate:SetFontSize(18)
  self.calling_plate:SetFontColor(0.4,0.3,0.3,0.8)
  self.calling_plate:SetVisible(false)
  
  -- self.silhouette
  self.silhouette = UI.CreateFrame("Texture", "BOTFUIDetailSilhouette", self.theBook.bookFrame)
  self.silhouette:SetTexture("BOTF", "media/warrior.png")
  self.silhouette:SetWidth(150)
  self.silhouette:SetHeight(250)
  self.silhouette:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 160, 10)
  self.silhouette:SetLayer(2)
  self.silhouette:SetVisible(false)

  self.lastName = false
  
end

-- update and display the UI elements
function BOTF.Book.Detail:show(name)

  local playerLevel = Inspect.Unit.Detail('player').level

  -- return without doing anything if we don't have a record
  if not BOTF_DB[name] then
    if self.lastName==false then
      return
    else
      name=self.lastName
    end
  end

  -- store in case we need to come back to the details page if someone clicks the details tab
  self.lastName=name

  -- set the background of the pageFrame
  if BOTF_DB[name].player==true then
    self.theBook.pagesFrame:SetTexture("BOTF", "media/book_details_pvp.png")
  else
    self.theBook.pagesFrame:SetTexture("BOTF", "media/book_details_pve.png")
  end

  -- lifetime
  self.lifetimeVictory_SoloKills = BOTF_DB[name].statistics.Victory_SoloKills
  self.lifetimeVictory_KillingBlows = BOTF_DB[name].statistics.Victory_KillingBlows
  self.lifetimeVictory_DamageAssists = BOTF_DB[name].statistics.Victory_DamageAssists
  self.lifetimeVictory_DistractAssists = BOTF_DB[name].statistics.Victory_DistractAssists
  self.lifetimeVictory_HealAssists = BOTF_DB[name].statistics.Victory_HealAssists
  self.lifetimeDefeat_SoloKills = BOTF_DB[name].statistics.Defeat_SoloKills
  self.lifetimeDefeat_KillingBlows = BOTF_DB[name].statistics.Defeat_KillingBlows
  self.lifetimeDefeat_DamageAssists = BOTF_DB[name].statistics.Defeat_DamageAssists
  self.lifetimeDefeat_DistractAssists = BOTF_DB[name].statistics.Defeat_DistractAssists
  self.lifetimeDefeat_HealAssists = BOTF_DB[name].statistics.Defeat_HealAssists
  -- session
  self.sessionVictory_SoloKills = BOTF_DB[name].session_statistics.Victory_SoloKills
  self.sessionVictory_KillingBlows = BOTF_DB[name].session_statistics.Victory_KillingBlows
  self.sessionVictory_DamageAssists = BOTF_DB[name].session_statistics.Victory_DamageAssists
  self.sessionVictory_DistractAssists = BOTF_DB[name].session_statistics.Victory_DistractAssists
  self.sessionVictory_HealAssists = BOTF_DB[name].session_statistics.Victory_HealAssists
  self.sessionDefeat_SoloKills = BOTF_DB[name].session_statistics.Defeat_SoloKills
  self.sessionDefeat_KillingBlows = BOTF_DB[name].session_statistics.Defeat_KillingBlows
  self.sessionDefeat_DamageAssists = BOTF_DB[name].session_statistics.Defeat_DamageAssists
  self.sessionDefeat_DistractAssists = BOTF_DB[name].session_statistics.Defeat_DistractAssists
  self.sessionDefeat_HealAssists = BOTF_DB[name].session_statistics.Defeat_HealAssists
  self.lifetime_score = 0
  if BOTF_DB[name].player==true then
    self.lifetime_score = ((1 * self.lifetimeVictory_SoloKills) + self.lifetimeVictory_KillingBlows + self.lifetimeVictory_DamageAssists + self.lifetimeVictory_DistractAssists + self.lifetimeVictory_HealAssists) - ((1 * self.lifetimeDefeat_SoloKills) + self.lifetimeDefeat_KillingBlows + self.lifetimeDefeat_DamageAssists + self.lifetimeDefeat_DistractAssists + self.lifetimeDefeat_HealAssists)
  else
    if BOTF_DB[name].level ~='unknown' and tonumber(BOTF_DB[name].level)>=tonumber(playerLevel) then
      self.lifetime_score = ((1 * self.lifetimeVictory_SoloKills) + self.lifetimeVictory_KillingBlows + self.lifetimeVictory_DamageAssists + self.lifetimeVictory_DistractAssists + self.lifetimeVictory_HealAssists) - ((1 * self.lifetimeDefeat_SoloKills) + self.lifetimeDefeat_KillingBlows + self.lifetimeDefeat_DamageAssists + self.lifetimeDefeat_DistractAssists + self.lifetimeDefeat_HealAssists)
    end
  end


  if self.lifetime_score > 0 then
    self.lifetime_score = "+" .. self.lifetime_score
  end
  self.lifetime_block = [[
   Victories:
       Solo:              ]] .. string.lpad(self.lifetimeVictory_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(self.lifetimeVictory_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(self.lifetimeVictory_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(self.lifetimeVictory_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(self.lifetimeVictory_HealAssists, 12, " ") .. [[

   Defeats:
       Solo:              ]] .. string.lpad(self.lifetimeDefeat_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(self.lifetimeDefeat_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(self.lifetimeDefeat_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(self.lifetimeDefeat_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(self.lifetimeDefeat_HealAssists, 12, " ") .. [[

   Score:                 ]] .. string.lpad(self.lifetime_score, 12, " ") .. [[
	]]
  self.session_score = 0
  if BOTF_DB[name].player==true then
    self.session_score = ((1 * self.sessionVictory_SoloKills) + self.sessionVictory_KillingBlows + self.sessionVictory_DamageAssists + self.sessionVictory_DistractAssists + self.sessionVictory_HealAssists) - ((1 * self.sessionDefeat_SoloKills) + self.sessionDefeat_KillingBlows + self.sessionDefeat_DamageAssists + self.sessionDefeat_DistractAssists + self.sessionDefeat_HealAssists)
  else
    if BOTF_DB[name].level ~='unknown' and tonumber(BOTF_DB[name].level)>=tonumber(playerLevel) then
      self.session_score = ((1 * self.sessionVictory_SoloKills) + self.sessionVictory_KillingBlows + self.sessionVictory_DamageAssists + self.sessionVictory_DistractAssists + self.sessionVictory_HealAssists) - ((1 * self.sessionDefeat_SoloKills) + self.sessionDefeat_KillingBlows + self.sessionDefeat_DamageAssists + self.sessionDefeat_DistractAssists + self.sessionDefeat_HealAssists)
    end
  end

  if self.session_score > 0 then
    self.session_score = "+" .. self.session_score
  end
  self.session_block = [[
   Victories:
       Solo:              ]] .. string.lpad(self.sessionVictory_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(self.sessionVictory_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(self.sessionVictory_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(self.sessionVictory_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(self.sessionVictory_HealAssists, 12, " ") .. [[

   Defeats:
       Solo:              ]] .. string.lpad(self.sessionDefeat_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(self.sessionDefeat_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(self.sessionDefeat_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(self.sessionDefeat_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(self.sessionDefeat_HealAssists, 12, " ") .. [[

   Score:                 ]] .. string.lpad(self.session_score, 12, " ") .. [[
	]]

  -- notes
  self.notesBlock:SetVisible(true)
  if BOTF_DB[name].last_seen_location then
    if BOTF_DB[name].session then
      self.notesBlock:SetText(name .. " was seen this session at \n" .. os.date('%H:%M:%S', BOTF_DB[name].last_seen_time) .. "\nin " .. BOTF_DB[name].last_seen_location..".")
    else
      self.notesBlock:SetText(name .. " was last seen in \n" .. BOTF_DB[name].last_seen_location.."\non " .. os.date("%a %b %d %Y at %H:%M:%S", BOTF_DB[name].last_seen_time) .. ".")
    end
  else
    if BOTF_DB[name].session then
      self.notesBlock:SetText(name .. " has been seen this \nsession.")
    else
      self.notesBlock:SetText(name .. " has not been seen this\nsession.")
    end
  end

  -- update the text frames and make them visible
  self.lifetimeDetailStats:SetText(self.lifetime_block)
  self.lifetimeDetailStats:SetVisible(true)
  self.sessionDetailStats:SetText(self.session_block)
  self.sessionDetailStats:SetVisible(true)

  -- name plate
  self.name_plate:SetText(name)
  self.name_plate:SetVisible(true)
  --self.name_plate:ResizeToText()

  self.name_plate:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 225-(self.name_plate:GetWidth()/2), -60)
  self.calling_plate:SetText(BOTF_DB[name].calling:gsub("^%l", string.upper) .. " - Level " .. BOTF_DB[name].level)
  self.calling_plate:SetVisible(true)
 -- self.calling_plate:ResizeToText()
  self.calling_plate:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 225-(self.calling_plate:GetWidth()/2), -18)

  --silhouette
  self.silhouette:SetVisible(true)
  self.silhouette:SetTexture("BOTF", "media/"..BOTF_DB[name].calling..".png")
 --self.silhouette:ResizeToTexture()
end

-- hide the UI elements
function BOTF.Book.Detail:hide()

  -- reset the contents of the text frames and hide them
  self.lifetimeDetailStats:SetText('')
  self.lifetimeDetailStats:SetVisible(false)
  self.sessionDetailStats:SetText('')
  self.sessionDetailStats:SetVisible(false)
  self.name_plate:SetText('')
  self.name_plate:SetVisible(false)
  self.calling_plate:SetText('')
  self.calling_plate:SetVisible(false)
  self.silhouette:SetVisible(false)
  self.notesBlock:SetText('')
  self.notesBlock:SetVisible(false)
end

