--[[
	Project: BookOfTheFallen
	Version: 1.0.0
	Author: NerfedWar (http://www.nerfedwar.net - nerfed.war@gmail.com)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

]]

-- initialise globals
if not BOTF then BOTF = {} end
if not BOTF.Book then BOTF.Book = {} end

-- @field define the Summary class
BOTF.Book.Summary = class(BOTF.Book.BasicPage)

-- Summary class constructor
-- @param book the Book pagesFrame
function BOTF.Book.Summary:init(book)

  -- @field store a reference to the Book pagesFrame
  self.theBook = book

  self.lifetimePVEStats = UI.CreateFrame("Text", "BOTFBookSummaryPVEStats", self.theBook.bookFrame)
  self.lifetimePVEStats:SetWidth(260)
  self.lifetimePVEStats:SetHeight(300)
  self.lifetimePVEStats:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 510, -33)
  self.lifetimePVEStats:SetLayer(2)
  self.lifetimePVEStats:SetText("")
  self.lifetimePVEStats:SetFont("BOTF", "MONOFONT.TTF")
  self.lifetimePVEStats:SetFontSize(15)
  self.lifetimePVEStats:SetFontColor(0.3, 0.2, 0.2, 1)
  self.lifetimePVEStats:SetVisible(true)

  self.sessionPVEStats = UI.CreateFrame("Text", "BOTFBookSummaryPVEStats", self.theBook.bookFrame)
  self.sessionPVEStats:SetWidth(260)
  self.sessionPVEStats:SetHeight(300)
  self.sessionPVEStats:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 510, 307)
  self.sessionPVEStats:SetLayer(2)
  self.sessionPVEStats:SetText("")
  self.sessionPVEStats:SetFont("BOTF", "MONOFONT.TTF")
  self.sessionPVEStats:SetFontSize(15)
  self.sessionPVEStats:SetFontColor(0.2, 0.3, 0.2, 1)
  self.sessionPVEStats:SetVisible(true)
  
  self.lifetimePVPStats = UI.CreateFrame("Text", "BOTFBookSummaryPVPStats", self.theBook.bookFrame)
  self.lifetimePVPStats:SetWidth(260)
  self.lifetimePVPStats:SetHeight(300)
  self.lifetimePVPStats:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 80, -33)
  self.lifetimePVPStats:SetLayer(2)
  self.lifetimePVPStats:SetText("")
  self.lifetimePVPStats:SetFont("BOTF", "MONOFONT.TTF")
  self.lifetimePVPStats:SetFontSize(15)
  self.lifetimePVPStats:SetFontColor(0.3, 0.2, 0.2, 1)
  self.lifetimePVPStats:SetVisible(true)

  self.sessionPVPStats = UI.CreateFrame("Text", "BOTFBookSummaryPVPStats", self.theBook.bookFrame)
  self.sessionPVPStats:SetWidth(260)
  self.sessionPVPStats:SetHeight(300)
  self.sessionPVPStats:SetPoint("TOPLEFT", self.theBook.bookFrame, "TOPLEFT", 80, 307)
  self.sessionPVPStats:SetLayer(2)
  self.sessionPVPStats:SetText("")
  self.sessionPVPStats:SetFont("BOTF", "MONOFONT.TTF")
  self.sessionPVPStats:SetFontSize(15)
  self.sessionPVPStats:SetFontColor(0.2, 0.3, 0.2, 1)
  self.sessionPVPStats:SetVisible(true)
end

-- update and display the UI elements
function BOTF.Book.Summary:show()

  -- set the background of the pageFrame
  self.theBook.pagesFrame:SetTexture("BOTF", "media/book_summary.png")

  -- perform statistics calculations

  -- session pve
  local pveLifetimeVictory_SoloKills = 0
  local pveLifetimeVictory_KillingBlows = 0
  local pveLifetimeVictory_DamageAssists = 0
  local pveLifetimeVictory_DistractAssists = 0
  local pveLifetimeVictory_HealAssists = 0
  local pveLifetimeDefeat_SoloKills = 0
  local pveLifetimeDefeat_KillingBlows = 0
  local pveLifetimeDefeat_DamageAssists = 0
  local pveLifetimeDefeat_DistractAssists = 0
  local pveLifetimeDefeat_HealAssists = 0
  local pveLifetimeScore = 0
  -- session pve
  local pveSessionVictory_SoloKills = 0
  local pveSessionVictory_KillingBlows = 0
  local pveSessionVictory_DamageAssists = 0
  local pveSessionVictory_DistractAssists = 0
  local pveSessionVictory_HealAssists = 0
  local pveSessionDefeat_SoloKills = 0
  local pveSessionDefeat_KillingBlows = 0
  local pveSessionDefeat_DamageAssists = 0
  local pveSessionDefeat_DistractAssists = 0
  local pveSessionDefeat_HealAssists = 0
  local pveSessionScore = 0

  -- session pvp
  local pvpLifetimeVictory_SoloKills = 0
  local pvpLifetimeVictory_KillingBlows = 0
  local pvpLifetimeVictory_DamageAssists = 0
  local pvpLifetimeVictory_DistractAssists = 0
  local pvpLifetimeVictory_HealAssists = 0
  local pvpLifetimeDefeat_SoloKills = 0
  local pvpLifetimeDefeat_KillingBlows = 0
  local pvpLifetimeDefeat_DamageAssists = 0
  local pvpLifetimeDefeat_DistractAssists = 0
  local pvpLifetimeDefeat_HealAssists = 0
  -- session pvp
  local pvpSessionVictory_SoloKills = 0
  local pvpSessionVictory_KillingBlows = 0
  local pvpSessionVictory_DamageAssists = 0
  local pvpSessionVictory_DistractAssists = 0
  local pvpSessionVictory_HealAssists = 0
  local pvpSessionDefeat_SoloKills = 0
  local pvpSessionDefeat_KillingBlows = 0
  local pvpSessionDefeat_DamageAssists = 0
  local pvpSessionDefeat_DistractAssists = 0
  local pvpSessionDefeat_HealAssists = 0

  local playerLevel = Inspect.Unit.Detail('player').level

  for i, v in pairs(BOTF_DB) do

    if string.sub(i, 1, 2) ~= "__" then
      if not v.player then

        pveLifetimeVictory_SoloKills = pveLifetimeVictory_SoloKills + v.statistics.Victory_SoloKills
        pveLifetimeVictory_KillingBlows = pveLifetimeVictory_KillingBlows + v.statistics.Victory_KillingBlows
        pveLifetimeVictory_DamageAssists = pveLifetimeVictory_DamageAssists + v.statistics.Victory_DamageAssists
        pveLifetimeVictory_DistractAssists = pveLifetimeVictory_DistractAssists + v.statistics.Victory_DistractAssists
        pveLifetimeVictory_HealAssists = pveLifetimeVictory_HealAssists + v.statistics.Victory_HealAssists
        pveLifetimeDefeat_SoloKills = pveLifetimeDefeat_SoloKills + v.statistics.Defeat_SoloKills
        pveLifetimeDefeat_KillingBlows = pveLifetimeDefeat_KillingBlows + v.statistics.Defeat_KillingBlows
        pveLifetimeDefeat_DamageAssists = pveLifetimeDefeat_DamageAssists + v.statistics.Defeat_DamageAssists
        pveLifetimeDefeat_DistractAssists = pveLifetimeDefeat_DistractAssists + v.statistics.Defeat_DistractAssists
        pveLifetimeDefeat_HealAssists = pveLifetimeDefeat_HealAssists + v.statistics.Defeat_HealAssists
        if v.level~='unknown' and tonumber(v.level)>= tonumber(playerLevel) then
          pveLifetimeScore = pveLifetimeScore + (((1 * v.statistics.Victory_SoloKills) + v.statistics.Victory_KillingBlows + v.statistics.Victory_DamageAssists + v.statistics.Victory_DistractAssists + v.statistics.Victory_HealAssists) - ((1 * v.statistics.Defeat_SoloKills) + v.statistics.Defeat_KillingBlows + v.statistics.Defeat_DamageAssists + v.statistics.Defeat_DistractAssists + v.statistics.Defeat_HealAssists))
        end
        pveSessionVictory_SoloKills = pveSessionVictory_SoloKills + v.session_statistics.Victory_SoloKills
        pveSessionVictory_KillingBlows = pveSessionVictory_KillingBlows + v.session_statistics.Victory_KillingBlows
        pveSessionVictory_DamageAssists = pveSessionVictory_DamageAssists + v.session_statistics.Victory_DamageAssists
        pveSessionVictory_DistractAssists = pveSessionVictory_DistractAssists + v.session_statistics.Victory_DistractAssists
        pveSessionVictory_HealAssists = pveSessionVictory_HealAssists + v.session_statistics.Victory_HealAssists
        pveSessionDefeat_SoloKills = pveSessionDefeat_SoloKills + v.session_statistics.Defeat_SoloKills
        pveSessionDefeat_KillingBlows = pveSessionDefeat_KillingBlows + v.session_statistics.Defeat_KillingBlows
        pveSessionDefeat_DamageAssists = pveSessionDefeat_DamageAssists + v.session_statistics.Defeat_DamageAssists
        pveSessionDefeat_DistractAssists = pveSessionDefeat_DistractAssists + v.session_statistics.Defeat_DistractAssists
        pveSessionDefeat_HealAssists = pveSessionDefeat_HealAssists + v.session_statistics.Defeat_HealAssists
        if v.level~='unknown' and tonumber(v.level)>= tonumber(playerLevel) then
          pveSessionScore = pveSessionScore + (((1 * v.session_statistics.Victory_SoloKills) + v.session_statistics.Victory_KillingBlows + v.session_statistics.Victory_DamageAssists + v.session_statistics.Victory_DistractAssists + v.session_statistics.Victory_HealAssists) - ((1 * v.session_statistics.Defeat_SoloKills) + v.session_statistics.Defeat_KillingBlows + v.session_statistics.Defeat_DamageAssists + v.session_statistics.Defeat_DistractAssists + v.session_statistics.Defeat_HealAssists))
        end
      else
        pvpLifetimeVictory_SoloKills = pvpLifetimeVictory_SoloKills + v.statistics.Victory_SoloKills
        pvpLifetimeVictory_KillingBlows = pvpLifetimeVictory_KillingBlows + v.statistics.Victory_KillingBlows
        pvpLifetimeVictory_DamageAssists = pvpLifetimeVictory_DamageAssists + v.statistics.Victory_DamageAssists
        pvpLifetimeVictory_DistractAssists = pvpLifetimeVictory_DistractAssists + v.statistics.Victory_DistractAssists
        pvpLifetimeVictory_HealAssists = pvpLifetimeVictory_HealAssists + v.statistics.Victory_HealAssists
        pvpLifetimeDefeat_SoloKills = pvpLifetimeDefeat_SoloKills + v.statistics.Defeat_SoloKills
        pvpLifetimeDefeat_KillingBlows = pvpLifetimeDefeat_KillingBlows + v.statistics.Defeat_KillingBlows
        pvpLifetimeDefeat_DamageAssists = pvpLifetimeDefeat_DamageAssists + v.statistics.Defeat_DamageAssists
        pvpLifetimeDefeat_DistractAssists = pvpLifetimeDefeat_DistractAssists + v.statistics.Defeat_DistractAssists
        pvpLifetimeDefeat_HealAssists = pvpLifetimeDefeat_HealAssists + v.statistics.Defeat_HealAssists

        pvpSessionVictory_SoloKills = pvpSessionVictory_SoloKills + v.session_statistics.Victory_SoloKills
        pvpSessionVictory_KillingBlows = pvpSessionVictory_KillingBlows + v.session_statistics.Victory_KillingBlows
        pvpSessionVictory_DamageAssists = pvpSessionVictory_DamageAssists + v.session_statistics.Victory_DamageAssists
        pvpSessionVictory_DistractAssists = pvpSessionVictory_DistractAssists + v.session_statistics.Victory_DistractAssists
        pvpSessionVictory_HealAssists = pvpSessionVictory_HealAssists + v.session_statistics.Victory_HealAssists
        pvpSessionDefeat_SoloKills = pvpSessionDefeat_SoloKills + v.session_statistics.Defeat_SoloKills
        pvpSessionDefeat_KillingBlows = pvpSessionDefeat_KillingBlows + v.session_statistics.Defeat_KillingBlows
        pvpSessionDefeat_DamageAssists = pvpSessionDefeat_DamageAssists + v.session_statistics.Defeat_DamageAssists
        pvpSessionDefeat_DistractAssists = pvpSessionDefeat_DistractAssists + v.session_statistics.Defeat_DistractAssists
        pvpSessionDefeat_HealAssists = pvpSessionDefeat_HealAssists + v.session_statistics.Defeat_HealAssists
      end
    end
  end
  if pveLifetimeScore > 0 then
    pveLifetimeScore = "+" .. pveLifetimeScore
  end
  local pve_lifetime_block = [[
   Victories:
       Solo:              ]] .. string.lpad(pveLifetimeVictory_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(pveLifetimeVictory_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(pveLifetimeVictory_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(pveLifetimeVictory_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(pveLifetimeVictory_HealAssists, 12, " ") .. [[

   Defeats:
       Solo:              ]] .. string.lpad(pveLifetimeDefeat_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(pveLifetimeDefeat_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(pveLifetimeDefeat_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(pveLifetimeDefeat_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(pveLifetimeDefeat_HealAssists, 12, " ") .. [[

   Score:                 ]] .. string.lpad(pveLifetimeScore, 12, " ") .. [[
	]]
  if pveSessionScore > 0 then
    pveSessionScore = "+" .. pveSessionScore
  end
  local pve_session_block = [[
   Victories:
       Solo:              ]] .. string.lpad(pveSessionVictory_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(pveSessionVictory_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(pveSessionVictory_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(pveSessionVictory_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(pveSessionVictory_HealAssists, 12, " ") .. [[

   Defeats:
       Solo:              ]] .. string.lpad(pveSessionDefeat_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(pveSessionDefeat_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(pveSessionDefeat_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(pveSessionDefeat_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(pveSessionDefeat_HealAssists, 12, " ") .. [[

   Score:                 ]] .. string.lpad(pveSessionScore, 12, " ") .. [[
	]]
  
  
  local pvp_lifetime_score = ((1 * pvpLifetimeVictory_SoloKills) + pvpLifetimeVictory_KillingBlows + pvpLifetimeVictory_DamageAssists + pvpLifetimeVictory_DistractAssists + pvpLifetimeVictory_HealAssists) - ((1 * pvpLifetimeDefeat_SoloKills) + pvpLifetimeDefeat_KillingBlows + pvpLifetimeDefeat_DamageAssists + pvpLifetimeDefeat_DistractAssists + pvpLifetimeDefeat_HealAssists)
  if pvp_lifetime_score > 0 then
    pvp_lifetime_score = "+" .. pvp_lifetime_score
  end
  local pvp_lifetime_block = [[
   Victories:
       Solo:              ]] .. string.lpad(pvpLifetimeVictory_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(pvpLifetimeVictory_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(pvpLifetimeVictory_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(pvpLifetimeVictory_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(pvpLifetimeVictory_HealAssists, 12, " ") .. [[

   Defeats:
       Solo:              ]] .. string.lpad(pvpLifetimeDefeat_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(pvpLifetimeDefeat_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(pvpLifetimeDefeat_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(pvpLifetimeDefeat_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(pvpLifetimeDefeat_HealAssists, 12, " ") .. [[

   Score:                 ]] .. string.lpad(pvp_lifetime_score, 12, " ") .. [[
	]]
  local pvp_session_score = ((1 * pvpSessionVictory_SoloKills) + pvpSessionVictory_KillingBlows + pvpSessionVictory_DamageAssists + pvpSessionVictory_DistractAssists + pvpSessionVictory_HealAssists) - ((1 * pvpSessionDefeat_SoloKills) + pvpSessionDefeat_KillingBlows + pvpSessionDefeat_DamageAssists + pvpSessionDefeat_DistractAssists + pvpSessionDefeat_HealAssists)
  if pvp_session_score > 0 then
    pvp_session_score = "+" .. pvp_session_score
  end
  local pvp_session_block = [[
   Victories:
       Solo:              ]] .. string.lpad(pvpSessionVictory_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(pvpSessionVictory_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(pvpSessionVictory_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(pvpSessionVictory_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(pvpSessionVictory_HealAssists, 12, " ") .. [[

   Defeats:
       Solo:              ]] .. string.lpad(pvpSessionDefeat_SoloKills, 12, " ") .. [[

       Killing blows:     ]] .. string.lpad(pvpSessionDefeat_KillingBlows, 12, " ") .. [[

       Damage assists:    ]] .. string.lpad(pvpSessionDefeat_DamageAssists, 12, " ") .. [[

       Distract assists:  ]] .. string.lpad(pvpSessionDefeat_DistractAssists, 12, " ") .. [[

       Heal assists:      ]] .. string.lpad(pvpSessionDefeat_HealAssists, 12, " ") .. [[

   Score:                 ]] .. string.lpad(pvp_session_score, 12, " ") .. [[
	]]

  -- update the text frames and make them visible
  self.lifetimePVEStats:SetText(pve_lifetime_block)
  self.lifetimePVEStats:SetVisible(true)
  self.sessionPVEStats:SetText(pve_session_block)
  self.sessionPVEStats:SetVisible(true)

  self.lifetimePVPStats:SetText(pvp_lifetime_block)
  self.lifetimePVPStats:SetVisible(true)
  self.sessionPVPStats:SetText(pvp_session_block)
  self.sessionPVPStats:SetVisible(true)
end

-- hide the UI elements
function BOTF.Book.Summary:hide()

  -- reset the contents of the text frames and hide them
  self.lifetimePVEStats:SetText('')
  self.lifetimePVEStats:SetVisible(false)
  self.sessionPVEStats:SetText('')
  self.sessionPVEStats:SetVisible(false)

  self.lifetimePVPStats:SetText('')
  self.lifetimePVPStats:SetVisible(false)
  self.sessionPVPStats:SetText('')
  self.sessionPVPStats:SetVisible(false)
end

